## ros-iron-rmw-cyclonedds-cpp 1.6.0

=== CMakeLists.txt ===
# Copyright 2018 ADLINK Technology Limited.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.5)

project(rmw_cyclonedds_cpp)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Wimplicit-fallthrough)
endif()

find_package(ament_cmake_ros REQUIRED)

find_package(rcutils REQUIRED)
find_package(rcpputils REQUIRED)
find_package(tracetools REQUIRED)

#find_package(cyclonedds_cmake_module REQUIRED)
find_package(CycloneDDS QUIET CONFIG)
if(CycloneDDS_FOUND)
  # Support for shared memory in RMW depends on support for shared memory being compiled in
  # Cyclone DDS and iceoryx_binding_c being available
  get_target_property(_cyclonedds_has_shm CycloneDDS::ddsc SHM_SUPPORT_IS_AVAILABLE)
  if(_cyclonedds_has_shm)
    find_package(iceoryx_binding_c REQUIRED)
  else()
    message(STATUS "Cyclone DDS is NOT compiled with support for shared memory")
  endif()
else()
  message(WARNING "Could not find Eclipse Cyclone DDS - skipping '${PROJECT_NAME}'")
  ament_package()
  return()
endif()

find_package(rmw REQUIRED)
find_package(rmw_dds_common REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(rosidl_typesupport_introspection_c REQUIRED)
find_package(rosidl_typesupport_introspection_cpp REQUIRED)

if(_cyclonedds_has_shm)
  ament_export_dependencies(iceoryx_binding_c)
endif()
ament_export_dependencies(CycloneDDS)
ament_export_dependencies(rcutils)
ament_export_dependencies(rcpputils)
ament_export_dependencies(rmw)
ament_export_dependencies(rosidl_runtime_c)
ament_export_dependencies(rmw_dds_common)
ament_export_dependencies(rosidl_typesupport_introspection_c)
ament_export_dependencies(rosidl_typesupport_introspection_cpp)
ament_export_dependencies(tracetools)

add_library(rmw_cyclonedds_cpp
  src/rmw_get_network_flow_endpoints.cpp
  src/rmw_node.cpp
  src/serdata.cpp
  src/serdes.cpp
  src/u16string.cpp
  src/exception.cpp
  src/demangle.cpp
  src/deserialization_exception.cpp
  src/Serialization.cpp
  src/TypeSupport2.cpp
  src/TypeSupport.cpp)

target_link_libraries(rmw_cyclonedds_cpp PRIVATE
  CycloneDDS::ddsc)

if(_cyclonedds_has_shm)
  target_link_libraries(rmw_cyclonedds_cpp PRIVATE iceoryx_binding_c::iceoryx_binding_c)
endif()

target_link_libraries(rmw_cyclonedds_cpp PUBLIC
  rmw::rmw)
target_link_libraries(rmw_cyclonedds_cpp PRIVATE
  rcutils::rcutils
  rcpputils::rcpputils
  rosidl_typesupport_introspection_c::rosidl_typesupport_introspection_c
  rosidl_typesupport_introspection_cpp::rosidl_typesupport_introspection_cpp
  rmw_dds_common::rmw_dds_common_library
  rosidl_runtime_c::rosidl_runtime_c
  tracetools::tracetools)

if(CMAKE_GENERATOR_PLATFORM)
  set(TARGET_ARCH "${CMAKE_GENERATOR_PLATFORM}")
else()
  set(TARGET_ARCH "${CMAKE_SYSTEM_PROCESSOR}")
endif()

if(CMAKE_COMPILER_IS_GNUCXX AND TARGET_ARCH MATCHES "^(riscv|RISCV)64$")
  # using GCC, libatomic is not automatically linked for RISC-V
  target_link_libraries(rmw_cyclonedds_cpp PUBLIC -latomic)
endif()

configure_rmw_library(rmw_cyclonedds_cpp)

target_compile_definitions(${PROJECT_NAME}
  PRIVATE
    RMW_VERSION_MAJOR=${rmw_VERSION_MAJOR}
    RMW_VERSION_MINOR=${rmw_VERSION_MINOR}
    RMW_VERSION_PATCH=${rmw_VERSION_PATCH}
)

ament_export_targets(export_rmw_cyclonedds_cpp)

register_rmw_implementation(
  "c:rosidl_typesupport_c:rosidl_typesupport_introspection_c"
  "cpp:rosidl_typesupport_cpp:rosidl_typesupport_introspection_cpp")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

install(
  TARGETS rmw_cyclonedds_cpp
  EXPORT export_rmw_cyclonedds_cpp
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

include(cmake/get_rmw_cyclonedds_output_filter.cmake)
get_rmw_cyclonedds_output_filter(rmw_cyclonedds_output_patterns)
ament_index_register_resource("rmw_output_patterns" CONTENT "${rmw_cyclonedds_output_patterns}")

=== debian/changelog ===
ros-iron-rmw-cyclonedds-cpp (1.6.0-2jammy) jammy; urgency=high

  * Dynamic Subscription (BONUS: Allocators): rmw_cyclonedds (#451 <https://github.com/ros2/rmw_cyclonedds/issues/451>)
  * Add stubs for new rmw interfaces (#447 <https://github.com/ros2/rmw_cyclonedds/issues/447>)
  * [rmw_cyclonedds] Improve handling of dynamic discovery (#429 <https://github.com/ros2/rmw_cyclonedds/issues/429>)
  * Call get_type_hash_func (#448 <https://github.com/ros2/rmw_cyclonedds/issues/448>)
  * Type hash distribution in discovery (rep2011) (#437 <https://github.com/ros2/rmw_cyclonedds/issues/437>)
  * Disable inconsistent topic events. (#444 <https://github.com/ros2/rmw_cyclonedds/issues/444>)
  * Implement matched event (#435 <https://github.com/ros2/rmw_cyclonedds/issues/435>)
  * Implement inconsistent topic. (#431 <https://github.com/ros2/rmw_cyclonedds/issues/431>)
  * Contributors: Barry Xu, Chris Lalancette, Emerson Knapp, Geoffrey Biggs, methylDragon

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 11 Apr 2023 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.5.1-2jammy) jammy; urgency=high

  * Make sure to add semicolons to the CHECK_TYPE_IDENTIFIER_MATCH. (#432 <https://github.com/ros2/rmw_cyclonedds/issues/432>)
  * [rolling] Update maintainers - 2022-11-07 (#428 <https://github.com/ros2/rmw_cyclonedds/issues/428>)
  * Contributors: Audrow Nash, Chris Lalancette

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 13 Feb 2023 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.5.0-2jammy) jammy; urgency=high

  * Export CycloneDDS dependency (#424 <https://github.com/ros2/rmw_cyclonedds/issues/424>)
  * add NULL check before accessing object. (#423 <https://github.com/ros2/rmw_cyclonedds/issues/423>)
  * Add rmw_get_gid_for_client impl (#402 <https://github.com/ros2/rmw_cyclonedds/issues/402>)
  * Makes topic_name a const ref
  * Adds topic name to error msg when create_topic fails
  * Contributors: Brian, Shane Loretz, Tomoya Fujita, Tully Foote, Voldivh

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 01 Nov 2022 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.4.1-2jammy) jammy; urgency=high

  * Improve error message when create_topic fails (#405 <https://github.com/ros2/rmw_cyclonedds/issues/405>)
  * Change wrong use of %d to print uint32_t to PRIu32 (#253 <https://github.com/ros2/rmw_cyclonedds/issues/253>)
  * Add cstring include. (#393 <https://github.com/ros2/rmw_cyclonedds/issues/393>)
  * Contributors: Chris Lalancette, Shane Loretz, eboasson

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 12 Sep 2022 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.4.0-2jammy) jammy; urgency=high

  * Handle 'best_available' QoS policies (#389 <https://github.com/ros2/rmw_cyclonedds/issues/389>)
  * Contributors: Jose Luis Rivero

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 02 May 2022 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.3.3-2jammy) jammy; urgency=high

  * Fix get_topic_name and handling long service names
  * Contributors: Erik Boasson

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 05 Apr 2022 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.3.2-2jammy) jammy; urgency=high

  * Add serialization for SDK_DATA
  * Additional checks for loan API
  * Contributors: Dietrich Krönke

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 04 Apr 2022 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.3.1-2jammy) jammy; urgency=high

  * Depend on just rmw_dds_common::rmw_dds_common_library (#385 <https://github.com/ros2/rmw_cyclonedds/issues/385>)
  * Contributors: Shane Loretz

 -- Erik Boasson <erik.boasson@adlinktech.com>  Wed, 30 Mar 2022 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.3.0-2jammy) jammy; urgency=high

  * Fix error message in rmw_init_options_copy(). (#380 <https://github.com/ros2/rmw_cyclonedds/issues/380>)
  * Add content filter topic feature empty stub. (#289 <https://github.com/ros2/rmw_cyclonedds/issues/289>)
  * Update to work with Cyclone 0.9.0 and Iceoryx 2.0 (#379 <https://github.com/ros2/rmw_cyclonedds/issues/379>)
  * Fill message info sequence numbers as unsupported, add rmw_feature_supported() implementation. (#381 <https://github.com/ros2/rmw_cyclonedds/issues/381>)
  * Contributors: Chen Lihui, Haowei Wen, Ivan Santiago Paunovic, Sumanth Nirmal

 -- Erik Boasson <erik.boasson@adlinktech.com>  Thu, 24 Mar 2022 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.2.0-2jammy) jammy; urgency=high

  * Fix a warning by making a pointer nullptr. (#375 <https://github.com/ros2/rmw_cyclonedds/issues/375>)
  * Bump QDs to QL2 (#371 <https://github.com/ros2/rmw_cyclonedds/issues/371>)
  * Add EventsExecutor (#256 <https://github.com/ros2/rmw_cyclonedds/issues/256>)
  * Call dissociate_reader in rmw_destroy_subscription
  * Wrap creation of new serdata_rmw within a try-catch block
  * Fix memory leak in error scenario on the publish side with SHM
  * Fix memory leaks on the take side with SHM
  * rename _cyclonedds_has_shm to follow the convention
  * Add iceoryx_binding_c as dependency to rmw_cyclonedds_cpp
  * Release iox_chunk to iceoryx in serdata_free if the iox_chunk is still available
  * Update iceoryx_subscriber also when constructing the serdata from the iox chunk
  * Contributors: Chris Lalancette, Christophe Bedard, Erik Boasson, Sumanth Nirmal, iRobot ROS

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 28 Feb 2022 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.1.2-2jammy) jammy; urgency=high

  * Fix cpplint errors (#363 <https://github.com/ros2/rmw_cyclonedds/issues/363>)
  * Contributors: Jacob Perron

 -- Erik Boasson <erik.boasson@adlinktech.com>  Thu, 13 Jan 2022 16:00:00 -0000

ros-iron-rmw-cyclonedds-cpp (1.1.1-2jammy) jammy; urgency=high

  * Updates for uncrustify 0.72 (#358 <https://github.com/ros2/rmw_cyclonedds/issues/358>)
  * Export only rmw::rmw to downstream targets (#360 <https://github.com/ros2/rmw_cyclonedds/issues/360>)
  * Export modern CMake targets (#357 <https://github.com/ros2/rmw_cyclonedds/issues/357>)


=== debian/control ===
Source: ros-iron-rmw-cyclonedds-cpp
Section: misc
Priority: optional
Maintainer: Erik Boasson <erik.boasson@adlinktech.com>
Build-Depends: debhelper (>= 9.0.0), ros-iron-ament-cmake-ros, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-cyclonedds, ros-iron-iceoryx-binding-c, ros-iron-rcpputils, ros-iron-rcutils, ros-iron-rmw, ros-iron-rmw-dds-common, ros-iron-rosidl-runtime-c, ros-iron-rosidl-typesupport-introspection-c, ros-iron-rosidl-typesupport-introspection-cpp, ros-iron-tracetools, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-rmw-cyclonedds-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-iron-cyclonedds, ros-iron-iceoryx-binding-c, ros-iron-rcpputils, ros-iron-rcutils, ros-iron-rmw, ros-iron-rmw-dds-common, ros-iron-rosidl-runtime-c, ros-iron-rosidl-typesupport-introspection-c, ros-iron-rosidl-typesupport-introspection-cpp, ros-iron-tracetools, ros-iron-ros-workspace
Description: Implement the ROS middleware interface using Eclipse CycloneDDS in C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-rmw-cyclonedds-cpp//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
